;; Entities Constants
entity_size = 34
e_ai_st_noAI = 0
e_ai_st_standby = 1
e_ai_st_move_to = 2
e_ai_st_patrol  = 3
e_ai_st_attack  = 4
e_ai_st_init_p  = 5
e_ai_st_aggro_p = 6
;; Entities offsets
e_x         = 0
e_y         = 1
e_vx        = 2
e_vy        = 3
e_w         = 4
e_h         = 5
e_lastVP_l  = 6
e_lastVP_h  = 7
e_sprite_l  = 8
e_sprite_h  = 9
e_doorId    = 10
e_health    = 11
e_stun      = 12
e_facing    = 13
e_last_facing =14
e_type      = 15
e_status    = 16
e_ai_x      = 17
e_ai_y      = 18
e_ai_status = 19
e_ai_prev_st = 20
e_ai_patrol_stepl = 21
e_ai_patrol_steph = 22
e_ai_patrol_type  = 23
e_anim_l    = 24
e_anim_h    = 25
e_anim_it   = 26
e_lastSprite_l   = 27
e_lastSprite_h   = 28
e_team      = 29
e_last_x    = 30
e_last_y    = 31
e_dsprite_l = 32
e_dsprite_h = 33

;; Entity facing constants
FACING_EAST  = 0
FACING_WEST  = 1
FACING_NORTH = 2
FACING_SOUTH = 3

;; Entity type constants
;; Entities with type values 20 or superior do not get damage or knockback
value_of_consecuence = 20

TYPE_PLAYER = 0
TYPE_ENEMY = 1
TYPE_BULLET = 15
TYPE_DOOR   = 20
TYPE_OBSTACLE = 21
TYPE_WALL   = 22
TYPE_OBJECT = 23
TYPE_SHIP   = 24

;; TEAMS
TEAM_PLAYER  = 1
TEAM_ENEMY   = 2
TEAM_NEUTRAL = 0

;; Entity Status constants
STATUS_ACTIVE = 1
STATUS_DEAD   = 0

;; Input functions
.globl entityman_init
.globl entityman_getEntityArray
.globl entityman_getNumEntities
.globl entityman_create
.globl entityman_eraseAllExceptPlayer
.globl entity_damage
.globl checkLife
.globl entityman_player_by_door
.globl entityman_getPlayerPos
.globl deactive_ix_bullet
.globl deactive_iy_bullet
.globl no_bullet
.globl bullet_shooted
.globl changeRoomDir
.globl entity_knockback
.globl restar_a_puntero
.globl sumar_puntero
.globl check_consecuenced_entity_ix
.globl check_consecuenced_entity_iy

;; Macros
.macro DefineEntity _name, _x, _y, _vx, _vy, _w, _h, _lastVP, _sprite, _doorId, _health, _stun, _facing, _ent_type, _status, _aiStatus, _patrol, _anim, _anim_it, _team, _dsprite
    _name::
        .db _x, _y                      ;; Position
        .db _vx, _vy                    ;; Velocity
        .db _w, _h                      ;; Size
        .dw _lastVP                     ;; Last Video Pointer
        .dw _sprite                     ;; Pointer to sprite
        .db _doorId                     ;; Pointer to ID Door / Type of Entity
        .db _health                     ;; Entity Health
        .db _stun                       ;; Entity stun (0/no stunned; >0 number of stunned iterations)
        .db _facing
        .db _facing                     ;; Entity is facing: north, west, est, south
        .db _ent_type                   ;; Type of entity
        .db _status                     ;; Status
        .db 0x00, 0x00                  ;; AI aiming x and y
        .db _aiStatus
        .db _aiStatus
        .dw 0x0000
        .db _patrol
        .dw _anim
        .db _anim_it
        .dw _sprite                     ;; Pointer to previos sprite
        .db _team                       ;; Entity team
        .db _x, _y
        .dw _dsprite
.endm
