;;     Game - PP The Space Mercenary
;;     Copyright (C) 2019  TeamBotella
;; 
;;     This program is free software: you can redistribute it and/or modify
;;     it under the terms of the GNU General Public License as published by
;;     the Free Software Foundation, either version 3 of the License, or
;;     (at your option) any later version.
;; 
;;     This program is distributed in the hope that it will be useful,
;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;     GNU General Public License for more details.
;; 
;;     You should have received a copy of the GNU General Public License
;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
.include "man/room.h.s"
.include "man/entity_manager.h.s"
.include "assets/assets.h.s"
.include "cpctelera.h.s"
.include "sys/render.h.s"
.include "man/animation.h.s"

;; Entity room: Max 4 Puertas, Max 5 Enemigos
;; Enemigos -> 7 Bytes; Puertas -> 4 Bytes (X,Y,Estado, ID)
;; Total -> 4*2 + 7*5 = 43 Bytes/room
num_rooms = 10
current_room:: .db 0
next_room:: .db #0x00

_room_array:       ;; Almacena los puntero a las funciones de las habitaciones
    .dw #_room_0
    .dw #_room_1
    .dw #_room_2
    .dw #_room_3
    .dw #_room_4
    .dw #_room_5
    .dw #_room_6
    .dw #_room_7
    .dw #_room_8
    .dw #_room_9

;; Entity = X, Y, VelX, VelY, Ancho, Alto, LVP_Low, LVP_High, Sprite, Door ID
;;Doors
puertas::
DefineEntity right_door, #0x4B, #0x53, #0x00, #0x00, #0x01, #0x14, #0xDB6B, #_sp_verticaldoor    , #1, #0xF0, 0, #FACING_EAST , #TYPE_DOOR, #STATUS_ACTIVE, e_ai_st_noAI, #0, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity left_door , #0x04, #0x53, #0x00, #0x00, #0x01, #0x14, #0xDB24, #_sp_verticaldoor    , #0, #0xF1, 0, #FACING_WEST , #TYPE_DOOR, #STATUS_ACTIVE, e_ai_st_noAI, #0, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity up_door   , #0x23, #0x08, #0x00, #0x00, #0x05, #0x04, #0xC02B, #_sp_horizontaldoor  , #3, #0xF2, 0, #FACING_NORTH, #TYPE_DOOR, #STATUS_ACTIVE, e_ai_st_noAI, #0, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity down_door , #0x23, #0xA4, #0x00, #0x00, #0x05, #0x04, #0xC7D3, #_sp_horizontaldoor  , #2, #0xF3, 0, #FACING_SOUTH, #TYPE_DOOR, #STATUS_ACTIVE, e_ai_st_noAI, #0, #0x0000, #0, #TEAM_NEUTRAL, #0

;;Spaceship 
DefineEntity sapceship, 36, 76, 0, 0, 12, 30, #0xC000, #_sp_bship, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity sapceship2, 36, 76, 0, 0, 12, 30, #0xC000, #_sp_spaceship, #-1, #3, 0, #FACING_WEST, #TYPE_SHIP, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity pize1, 60, 120, 0, 0, 4, 10, #0xC000, #_sp_part, #-1, #3, 0, #FACING_WEST, #TYPE_OBJECT, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity pize2, 66, 24, 0, 0, 4, 10, #0xC000, #_sp_part, #-1, #3, 0, #FACING_WEST, #TYPE_OBJECT, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity pize3, 8, 30, 0, 0, 4, 10, #0xC000, #_sp_part, #-1, #3, 0, #FACING_WEST, #TYPE_OBJECT, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0


;;Enemys
DefineEntity enemy11, 26, 24, 0, 0, 4, 10, #0xC000, #_sp_onlyhead_r_0, #-1, #2, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_attack, #1, _onlyhead_r_moving, #15, #TEAM_ENEMY, #_sp_onlyhead_r_3
DefineEntity enemy21, 36, 50, 0, 0, 4, 10, #0xC000, #_sp_onlyhead_g_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_noAI, #1, _onlyhead_g_moving, #15, #TEAM_ENEMY, #_sp_onlyhead_g_3
DefineEntity enemy22, 36, 130, 0, 0, 4, 10, #0xC000, #_sp_onlyhead_g_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_noAI, #1, _onlyhead_g_moving, #15, #TEAM_ENEMY, #_sp_onlyhead_g_3
DefineEntity enemy31, 30, 150, 0, 0, 4, 10, #0xC000, #_sp_onlyhead_g_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_noAI, #1, _onlyhead_g_moving, #15, #TEAM_ENEMY, #_sp_onlyhead_g_3
DefineEntity enemy32, 60, 80, 0, 0, 4, 10, #0xC000, #_sp_onlyhead_r_0, #-1, #2, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_attack, #1 , _onlyhead_r_moving, #15, #TEAM_ENEMY, #_sp_onlyhead_r_3
DefineEntity enemy41, 10, 80, 0, 0, 4, 10, #0xC000, #_sp_bouncyhead_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_standby, #1, _bouncyhead_moving, #15, #TEAM_ENEMY, #_sp_bouncyhead_3
DefineEntity enemy42, 52, 40, 0, 0, 4, 10, #0xC000, #_sp_bouncyhead_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_standby, #1, _bouncyhead_moving, #15, #TEAM_ENEMY, #_sp_bouncyhead_3
DefineEntity enemy51, 10, 40, 0, 0, 4, 16, #0xC000, #_sp_bighead_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_init_p, #1, _bighead_moving, #15, #TEAM_ENEMY, #_sp_bighead_3
DefineEntity enemy52, 36, 80, 0, 0, 4, 10, #0xC000, #_sp_onlyhead_r_0, #-1, #2, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_attack, #1, _onlyhead_r_moving, #15, #TEAM_ENEMY, #_sp_onlyhead_r_3
DefineEntity enemy61, 36, 14, 0, 0, 4, 16, #0xC000, #_sp_bighead_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_init_p, #5, _bighead_moving, #15, #TEAM_ENEMY, #_sp_bighead_3
DefineEntity enemy62, 40, 140, 0, 0, 4, 16, #0xC000, #_sp_bighead_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_init_p, #6, _bighead_moving, #15, #TEAM_ENEMY, #_sp_bighead_3
DefineEntity enemy71, 10, 80, 0, 0, 4, 16, #0xC000, #_sp_bighead_0, #-1, #4, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_init_p, #4, _bighead_moving, #15, #TEAM_ENEMY, #_sp_bighead_3
DefineEntity enemy72, 28, 40, 0, 0, 4, 16, #0xC000, #_sp_three_eyed_0, #-1, #6, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_aggro_p, #3, _three_eyed_moving, #15, #TEAM_ENEMY, #_sp_three_eyed_3
DefineEntity enemy81, 60, 90, 0, 0, 4, 16, #0xC000, #_sp_three_eyed_0, #-1, #6, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_aggro_p, #2, _three_eyed_moving, #15, #TEAM_ENEMY, #_sp_three_eyed_3
DefineEntity enemy82, 70, 80, 0, 0, 4, 16, #0xC000, #_sp_three_eyed_0, #-1, #6, 0, #FACING_WEST, #TYPE_ENEMY, #STATUS_ACTIVE, e_ai_st_standby, #1, _three_eyed_moving, #15, #TEAM_ENEMY, #_sp_three_eyed_3

;;Stones
DefineEntity stone41, 36, 90, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone42, 42, 90, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone43, 48, 90, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone44, 54, 90, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone45, 60, 90, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone46, 66, 90, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone47, 72, 90, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone48, 4, 8, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone49, 4, 22, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone40, 8, 8, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone61, 18, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone61d, 22, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone61i, 18, 54, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone61b, 22, 54, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone62, 18, 126, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone62d, 22, 126, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone62i, 18, 112, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone62b, 22, 112, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone63, 52, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone63d, 56, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone63i, 52, 54, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone63b, 56, 54, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone64, 52, 126, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone64d, 56, 126, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone64i, 52, 112, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone64b, 56, 112, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone21, 14, 38, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone22, 72, 8, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone23, 48, 152, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone24, 20, 118, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone25, 58, 72, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone26, 72, 22, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone27, 48, 138, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone28, 68, 8, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone29, 44, 152, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone20, 52, 152, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone30, 10, 100, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone10, 30, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone11, 38, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone12, 34, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone91, 4, 152, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone92, 4, 138, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone93, 8, 152, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone94, 72, 152, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone95, 72, 138, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stone96, 68, 152, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0



;;Wall1
DefineEntity wall31, 4, 8, 0, 0, 26, 56, #0xC000, #_sp_wall, #-1, #3, 0, #FACING_WEST, #TYPE_WALL, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu1, 4, 60, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu2, 10, 60, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu3, 16, 60, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu4, 22, 60, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu5, 28, 60, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu6, 29, 40, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu7, 29, 24, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu8, 29, 8, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0

;Wall2
DefineEntity wall51, 4, 116, 0, 0, 26, 56, #0xC000, #_sp_wall, #-1, #3, 0, #FACING_WEST, #TYPE_WALL, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu51, 4, 108, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu52, 10, 108, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu53, 16, 108, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu54, 22, 108, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu55, 28, 108, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu56, 28, 150, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu57, 28, 128, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0

;Wall3
DefineEntity wall71, 50, 112, 0, 0, 26, 56, #0xC000, #_sp_wall, #-1, #3, 0, #FACING_WEST, #TYPE_WALL, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu71, 48, 104, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu72, 54, 104, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu73, 60, 104, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu74, 66, 104, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu75, 72, 104, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu76, 48, 148, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0
DefineEntity stoneu77, 48, 126, 0, 0, 4, 16, #0xC000, #_sp_stone, #-1, #3, 0, #FACING_WEST, #TYPE_OBSTACLE, #STATUS_ACTIVE, e_ai_st_noAI, #1, #0x0000, #0, #TEAM_NEUTRAL, #0


;;
rooms_init::
    xor a
    ld (#current_room), a
    ld (#next_room), a
    ret

room_update::

    ld hl, #current_room
    ld a, (#next_room)
    ld b, (hl)
    cp b
    ret z

    push af
    call entityman_player_by_door
    pop af
    push af
    call load_room
    pop af
    ld (#current_room), a
    ret

;; INPUT => BC = (X,Y) ; HL = Etiqueta entity
_change_pos_x_y:
    ld de, #e_x
    push hl
    add hl, de
    ld (hl), b
    pop hl
    ld de, #e_y
    add hl, de
    ld (hl), c
    ret
;; A: ID number of the room to be loaded
;; DE: Destroyed
;; HL: Destroyed
;;  A: Destroyed
load_room::
    ld de, #_room_array
    add a, a
    add a, e
    ld e, a
    ld a, (de)
    ld l, a
    inc de
    ld a, (de)
    ld h, a
    push hl
    call entityman_eraseAllExceptPlayer
    call change_to_first_render
    pop hl
    jp (hl)


;; INPUT:   HL = ENTITY TO MODIFY ID
;;           A = ID TO LOAD
;; OUTPUT = Pointer to id in DE
_changeIDFromDoor:
    ex de, hl           ;; Leaves HL in DE, DE stores good adress
    ld hl, #e_doorId    ;; HL = Value of e_doorID const
    add hl, de          ;; HL = DE + HL

    ld (hl), a          ;; Changes ID of door by the value stored in A

    ex de, hl           ;; DE <-> HL

    ret

_room_0:
    ld hl, #up_door
    ld a, #1
    call _changeIDFromDoor
    call entityman_create

ret

_room_1:
    ld hl, #down_door
    xor a
    call _changeIDFromDoor
    call entityman_create

    ld hl, #right_door
    ld a, #2
    call _changeIDFromDoor
    call entityman_create

    ld hl, #enemy11
    call entityman_create

    ld hl, #stone10
    call entityman_create
    ld hl, #stone11
    call entityman_create
    ld hl, #stone12
    call entityman_create

ret

_room_2:
    ld hl, #left_door
    ld a, #1
    call _changeIDFromDoor
    call entityman_create

    ld hl, #right_door
    ld a, #3
    call _changeIDFromDoor
    call entityman_create


    ld hl, #enemy21
    call entityman_create

    ld hl, #enemy22
    call entityman_create

    ld hl, #stone21
    call entityman_create
    ld hl, #stone22
    call entityman_create
    ld hl, #stone23
    call entityman_create
    ld hl, #stone24
    call entityman_create
    ld hl, #stone25
    call entityman_create
    ld hl, #stone26
    call entityman_create
    ld hl, #stone27
    call entityman_create
    ld hl, #stone28
    call entityman_create
    ld hl, #stone29
    call entityman_create
    ld hl, #stone20
    call entityman_create

ret

_room_3:
    ld hl, #left_door
    ld a, #2
    call _changeIDFromDoor
    call entityman_create

    ld hl, #up_door
    ld a, #4
    call _changeIDFromDoor
    call entityman_create

    call entityman_getEntityArray
    ld  de, #e_ai_y
    add hl, de
    ld  a, (hl)
    or a
    jr nz, _no_object3

    ld hl, #pize1
    call entityman_create

    _no_object3:

    ld hl, #enemy31
    call entityman_create

    ld hl, #enemy32
    call entityman_create

    ld hl, #wall31
    call entityman_create
    ld hl, #stoneu1
    call entityman_create
    ld hl, #stoneu2
    call entityman_create
    ld hl, #stoneu3
    call entityman_create
    ld hl, #stoneu4
    call entityman_create
    ld hl, #stoneu5
    call entityman_create
    ld hl, #stoneu6
    call entityman_create
    ld hl, #stoneu7
    call entityman_create
    ld hl, #stoneu8
    call entityman_create

    ld hl, #stone30
    call entityman_create
ret

_room_4:
    ld hl, #down_door
    ld a, #3
    call _changeIDFromDoor
    call entityman_create

    ld hl, #up_door
    ld a, #5
    call _changeIDFromDoor
    call entityman_create

    ld hl, #enemy41
    call entityman_create

    ld hl, #enemy42
    call entityman_create

    ld hl, #stone41
    call entityman_create
    ld hl, #stone42
    call entityman_create
    ld hl, #stone43
    call entityman_create
    ld hl, #stone44
    call entityman_create
    ld hl, #stone45
    call entityman_create
    ld hl, #stone46
    call entityman_create
    ld hl, #stone47
    call entityman_create
    ld hl, #stone48
    call entityman_create
    ld hl, #stone49
    call entityman_create
    ld hl, #stone40
    call entityman_create
ret

_room_5:
    ld hl, #down_door
    ld a, #4
    call _changeIDFromDoor
    call entityman_create

    ld hl, #left_door
    ld a, #6
    call _changeIDFromDoor
    call entityman_create

    call entityman_getEntityArray
    ld  de, #e_ai_y
    add hl, de
    ld  a, (hl)
    cp #1
    jr nz, _no_object5

    ld hl, #pize2
    call entityman_create

    _no_object5:

    ld hl, #enemy51
    call entityman_create

    ld hl, #enemy52
    call entityman_create

    ld hl, #wall51
    call entityman_create

    ld hl, #stoneu51
    call entityman_create
    ld hl, #stoneu52
    call entityman_create
    ld hl, #stoneu53
    call entityman_create
    ld hl, #stoneu54
    call entityman_create
    ;ld hl, #stoneu55
    ;call entityman_create
    ld hl, #stoneu56
    call entityman_create
    ld hl, #stoneu57
    call entityman_create

    ld hl, #stone22
    call entityman_create
    ld hl, #stone26
    call entityman_create
    ld hl, #stone28
    call entityman_create
ret

_room_6:
    ld hl, #right_door
    ld a, #5
    call _changeIDFromDoor
    call entityman_create

    ld hl, #left_door
    ld a, #7
    call _changeIDFromDoor
    call entityman_create

    ld hl, #enemy61
    call entityman_create

    ld hl, #enemy62
    call entityman_create

    ld hl, #stone61i
    call entityman_create
    ld hl, #stone61b
    call entityman_create
    ld hl, #stone61d
    call entityman_create
    ;ld hl, #stone61
    ;call entityman_create

    ld hl, #stone62i
    call entityman_create
    ld hl, #stone62b
    call entityman_create
    ld hl, #stone62d
    call entityman_create
    ;ld hl, #stone62
    ;call entityman_create

    ld hl, #stone63i
    call entityman_create
    ld hl, #stone63b
    call entityman_create
    ;ld hl, #stone63d
    ;call entityman_create
    ld hl, #stone63
    call entityman_create

    ld hl, #stone64i
    call entityman_create
    ld hl, #stone64b
    call entityman_create
    ;ld hl, #stone64d
    ;call entityman_create
    ld hl, #stone64
    call entityman_create
ret

_room_7:
    ld hl, #right_door
    ld a, #6
    call _changeIDFromDoor
    call entityman_create

    ld hl, #down_door
    ld a, #8
    call _changeIDFromDoor
    call entityman_create

    call entityman_getEntityArray
    ld  de, #e_ai_y
    add hl, de
    ld  a, (hl)
    cp #2
    jr nz, _no_object7

    ld hl, #pize3
    call entityman_create

    _no_object7:

    ld hl, #enemy71
    call entityman_create

    ld hl, #enemy72
    call entityman_create

    ld hl, #wall71
    call entityman_create

    ;ld hl, #stoneu71
    ;call entityman_create
    ld hl, #stoneu72
    call entityman_create
    ld hl, #stoneu73
    call entityman_create
    ld hl, #stoneu74
    call entityman_create
    ld hl, #stoneu75
    call entityman_create
    ld hl, #stoneu76
    call entityman_create
    ld hl, #stoneu77
    call entityman_create

    ld hl, #stone24
    call entityman_create
    ld hl, #stone21
    call entityman_create
ret

_room_8:
    ld hl, #up_door
    ld a, #7
    call _changeIDFromDoor
    call entityman_create

    ld hl, #right_door
    ld a, #9
    call _changeIDFromDoor
    call entityman_create

    ld hl, #enemy81
    call entityman_create

    ld hl, #enemy82
    call entityman_create

    ld hl, #stone48
    call entityman_create
    ld hl, #stone49
    call entityman_create
    ld hl, #stone40
    call entityman_create

    ;ld hl, #stone62
    ;call entityman_create
    ;ld hl, #stone62b
    ;call entityman_create
    ld hl, #stone62d
    call entityman_create
    ld hl, #stone62i
    call entityman_create

    ld hl, #stone63
    call entityman_create
    ld hl, #stone63b
    call entityman_create
    ;ld hl, #stone63d
    ;call entityman_create
    ;ld hl, #stone63i
    ;call entityman_create

    ld hl, #stone23
    call entityman_create
    ld hl, #stone27
    call entityman_create
    ld hl, #stone29
    call entityman_create
    ld hl, #stone20
    call entityman_create

ret

_room_9:
    call entityman_getEntityArray
    ld  de, #e_ai_y
    add hl, de
    ld  a, (hl)
    cp #3
    jr z, _win
    ld hl, #down_door
    ld a, #2
    call _changeIDFromDoor
    call entityman_create

    ld hl, #sapceship
    call entityman_create
    jr  _not_win
    _win:

    ld hl, #sapceship2
    call entityman_create

    _not_win:
    ld hl, #stone22
    call entityman_create
    ld hl, #stone26
    call entityman_create
    ld hl, #stone28
    call entityman_create

    ld hl, #stone48
    call entityman_create
    ld hl, #stone49
    call entityman_create
    ld hl, #stone40
    call entityman_create

    ld hl, #stone91
    call entityman_create
    ld hl, #stone92
    call entityman_create
    ld hl, #stone93
    call entityman_create

    ld hl, #stone94
    call entityman_create
    ld hl, #stone95
    call entityman_create
    ld hl, #stone96
    call entityman_create

ret

change_room::
    ld (next_room), a
    ret