;;     Game - PP The Space Mercenary
;;     Copyright (C) 2019  TeamBotella
;; 
;;     This program is free software: you can redistribute it and/or modify
;;     it under the terms of the GNU General Public License as published by
;;     the Free Software Foundation, either version 3 of the License, or
;;     (at your option) any later version.
;; 
;;     This program is distributed in the hope that it will be useful,
;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;     GNU General Public License for more details.
;; 
;;     You should have received a copy of the GNU General Public License
;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
.include "man/entity_manager.h.s"
.include "man/patrol.h.s"

;;
;; INITS the ai control system
;;
sys_ai_control_init::
    ld  (_ent_array__ptr_tmp_standby), hl   ;Could be done better

    ld  (_ent_array_ptr), hl
    ret

sys_ai_standby::
_ent_array__ptr_tmp_standby = . + 2
    ld  iy, #0x0000

    ;ld  a, e_ai_x(iy)
    ;or  a
    ;ret z
    ld  a, e_x(iy)
    sub e_x(ix)
    jr  c, _otherway_x
    cp  #21
    jr  c, _comprob_y
    ret
_otherway_x:
    ld a, e_x(ix)
    sub e_x(iy)
    cp  #21
    jr  c, _comprob_y
    ret
_comprob_y:
    ld  a, e_y(iy)
    sub e_y(ix)
    jr  c, _otherway_y
    cp  #61
    jr  c, _close
    ret
_otherway_y:
    ld a, e_y(ix)
    sub e_y(iy)
    cp  #61
    ret nc
    
_close:
    ;ld  e_ai_prev_st(ix), #e_ai_st_standby
    ld  e_ai_status(ix), #e_ai_st_attack

    ret

sys_ai_attack::

    call entityman_getPlayerPos

    ld  a, d
    ld  e_ai_x(ix), a
    ld  a, e
    ld  e_ai_y(ix), a

    ld  e_ai_prev_st(ix), #e_ai_st_attack
    ld  e_ai_status(ix), #e_ai_st_move_to

    ret

sys_ai_move_to::

    ld  a, e_ai_x(ix)
    sub e_x(ix)
    jr  nc, _obj_greater_or_equalx
_obj_lessx:
    ld  e_vx(ix), #-1
    ld  a, #FACING_WEST
    ld  e_facing(ix), a
    jr _endifx
_obj_greater_or_equalx:
    jr  z, _equalx
    ld  e_vx(ix), #1
    ld  a, #FACING_EAST
    ld  e_facing(ix), a
    jr _endifx
_equalx:
    ld  e_vx(ix), #0
_endifx:

    ld  a, e_ai_y(ix)
    sub e_y(ix)
    jr  nc, _obj_greater_or_equaly
_obj_lessy:
    ld  e_vy(ix), #-2
    ld  a, #FACING_NORTH
    ld  e_facing(ix), a
    jr _endify
_obj_greater_or_equaly:
    jr  z, _equaly
    ld  e_vy(ix), #2
    ld  a, #FACING_SOUTH
    ld  e_facing(ix), a
    jr _endify
_equaly:
    ld  e_vy(ix), #0
    ld  a, e_vx(ix)
    or  a
    jr  nz, _endify
        ld  a, e_ai_prev_st(ix)
        cp  #e_ai_st_aggro_p
        jr  z, _status_aggro
        ld  e_ai_status(ix), a
        ld  e_ai_prev_st(ix), #e_ai_st_move_to
        jr _end_move_to
    _status_aggro:
        ld e_ai_status(ix), #e_ai_st_patrol
        jr _end_move_to
_endify:
    ld  a, e_ai_prev_st(ix)
    cp  #e_ai_st_aggro_p
    jr  nz, _end_move_to  
    call sys_ai_standby
    ld  a, e_ai_status(ix)
    cp  #e_ai_st_attack
    jr  z, _end_move_to
_end_move_to:
    xor a
    ret


sys_ai_patrol_init::
    ld  a, e_ai_patrol_type(ix)
    cp  #1
    call z, patrol_get01
    jr  z, _end_patrol_assign
    cp  #2
    call z, patrol_get02
    jr  z, _end_patrol_assign
    cp  #3
    call z, patrol_get03
    jr  z, _end_patrol_assign
    cp  #4
    call z, patrol_get04
    jr  z, _end_patrol_assign
    cp  #5
    call z, patrol_get05
    jr  z, _end_patrol_assign
    cp  #6
    call z, patrol_get06
    jr  z, _end_patrol_assign
    ret nz

_end_patrol_assign:
    ld  e_ai_patrol_stepl(ix), l
    ld  e_ai_patrol_steph(ix), h
    ;ld  e_ai_prev_st(ix), #e_ai_st_init_p
    ld  e_ai_status(ix), #e_ai_st_patrol
    ret

sys_ai_patrol::
    ld l, e_ai_patrol_stepl(ix)
    ld h, e_ai_patrol_steph(ix)

    ld a, (hl)
    cp #patrol_invalid_move
    jr z, _reset_patrol

    ld e_ai_x(ix), a
    inc hl
    ld a, (hl)
    ld e_ai_y(ix), a

    inc hl
    ld e_ai_patrol_stepl(ix), l
    ld e_ai_patrol_steph(ix), h

    ld a, e_ai_prev_st(ix)
    cp #e_ai_st_aggro_p
    jr z, _aggro
    ld e_ai_prev_st(ix), #e_ai_st_patrol
_aggro:
    ld e_ai_status(ix), #e_ai_st_move_to
    xor a
    ret

_reset_patrol:
    inc hl
    ld a, (hl)
    inc hl
    ld h, (hl)
    
    ld e_ai_patrol_stepl(ix), a
    ld e_ai_patrol_steph(ix), h

    ret



sys_ai_control_update:: 

    ld  (_ent_counter), a
_ent_array_ptr = . + 2
    ld ix, #0x0000

_loop:
    ld  a, e_ai_status(ix)
    cp  #e_ai_st_noAI
    jr  z, _no_AI_ent
_AI_ent:
    cp  #e_ai_st_standby
    call z, sys_ai_standby
    cp  #e_ai_st_move_to
    call z, sys_ai_move_to
    cp  #e_ai_st_attack
    call z, sys_ai_attack
    cp  #e_ai_st_patrol
    call z, sys_ai_patrol
    cp  #e_ai_st_init_p
    call z, sys_ai_patrol_init
    cp  #e_ai_st_aggro_p
    call z, sys_ai_patrol_init


_no_AI_ent:

_ent_counter = . + 1
    ld  a, #0
    dec a
    ret z
    ld  (_ent_counter), a
    ld  de, #entity_size
    add ix, de

    jr _loop