;;     Game - PP The Space Mercenary
;;     Copyright (C) 2019  TeamBotella
;; 
;;     This program is free software: you can redistribute it and/or modify
;;     it under the terms of the GNU General Public License as published by
;;     the Free Software Foundation, either version 3 of the License, or
;;     (at your option) any later version.
;; 
;;     This program is distributed in the hope that it will be useful,
;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;     GNU General Public License for more details.
;; 
;;     You should have received a copy of the GNU General Public License
;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
.include "assets/assets.h.s"
.include "man/animation.h.s"
.include "man/entity_manager.h.s"
.include "cpctelera.h.s"

sys_animation_update::
    ld l, e_anim_l(ix)
    ld h, e_anim_h(ix)
    _continueAnime:
    ld c, (hl)
    inc hl
    ld b, (hl)

    ld a, c
    or b
    jr z, _resetAnim

    ld e_sprite_l(ix), c
    ld e_sprite_h(ix), b
    inc hl
    ld e_anim_l(ix), l
    ld e_anim_h(ix), h
    ret

_resetAnim:
    inc hl
    ld a, (hl)
    inc hl
    ld h, (hl)
    ld l, a
    jr _continueAnime

check_animado::
    ld a, e_type(ix)
    cp #2
    jr nc, _no_anime
    
    call sys_animation_update

    _no_anime:
    ret

_animations_pp: .dw _pp_walking_right, _pp_walking_left, _pp_walking_up, _pp_walking_down
change_animation_facing::
    ld hl, #_animations_pp
    ld a, e_facing(ix)
    add a
    call sumar_puntero
    ld a, (hl)
    inc hl
    ld h, (hl)
    ld l, a
    ld e_anim_l(ix), l
    ld e_anim_h(ix), h
    ld a, #1
    ld e_anim_it(ix), a
    ret