;;     Game - PP The Space Mercenary
;;     Copyright (C) 2019  TeamBotella
;; 
;;     This program is free software: you can redistribute it and/or modify
;;     it under the terms of the GNU General Public License as published by
;;     the Free Software Foundation, either version 3 of the License, or
;;     (at your option) any later version.
;; 
;;     This program is distributed in the hope that it will be useful,
;;     but WITHOUT ANY WARRANTY; without even the implied warranty of
;;     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;     GNU General Public License for more details.
;; 
;;     You should have received a copy of the GNU General Public License
;;     along with this program.  If not, see <https://www.gnu.org/licenses/>.
.include "input.h.s"
.include "cpctelera.h.s"
.include "man/entity_manager.h.s"
.globl cpct_setDrawCharM0_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawStringM0_asm
.globl menu

sys_input_init::
    ld (_ent_ptr), hl
    ret

sys_input_update::

_ent_ptr = .+2
    ld ix, #0x0000

    ;; Reset velocities
    ld e_vx(ix), #0
    ld e_vy(ix), #0
    ld a, e_facing(ix)
    ld e_last_facing(ix), a

    ;; Scan the keyboard
    call cpct_scanKeyboard_f_asm

    ;; Check for movement keys
    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    jr z, O_NotPressed
    O_Pressed:
        ld e_vx(ix), #-1
        ld e_facing(ix), #FACING_WEST
    O_NotPressed:
        ld hl, #Key_P
        call cpct_isKeyPressed_asm
        jr z, P_NotPressed
    P_Pressed:
        ld e_vx(ix), #1
        ld e_facing(ix), #FACING_EAST
    P_NotPressed:
        ld hl, #Key_Q
        call cpct_isKeyPressed_asm
        jr z, Q_NotPressed
    Q_Pressed:
        ld e_vy(ix), #-2
        ld e_facing(ix), #FACING_NORTH
    Q_NotPressed:
        ld hl, #Key_A
        call cpct_isKeyPressed_asm
        jr z, A_NotPressed
    A_Pressed:
        ld e_vy(ix), #2
        ld e_facing(ix), #FACING_SOUTH
    A_NotPressed:
    _check_restart:
        ld hl, #Key_R
        call cpct_isKeyPressed_asm
        jr nz, R_Pressed
    _check_escape:
        ld hl, #Key_Esc
        call cpct_isKeyPressed_asm
        call nz, _pause
    _check_space:
        ld hl, #Key_Space
        call cpct_isKeyPressed_asm
        jr z, Space_NotPressed
    Space_Pressed:
        or #1
    Space_NotPressed:

    _end_input:
    ret

    R_Pressed:
        call cpct_scanKeyboard_f_asm
        ld hl, #Key_R
        call cpct_isKeyPressed_asm
        jr nz, R_Pressed
        jp menu

string: .asciz "PAUSED"
_pause:
    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr nz, _pause

    ld    l, #15
    ld    h, #3
    call cpct_setDrawCharM0_asm
    ld de, #0xC000
    ld c, #28
    ld b, #192
    call cpct_getScreenPtr_asm
    ld   iy, #string 
    call cpct_drawStringM0_asm

    _pause_2:
        call cpct_scanKeyboard_f_asm
        ld hl, #Key_Esc
        call cpct_isKeyPressed_asm
        jr z, _pause_2

    _pause_3:
        call cpct_scanKeyboard_f_asm
        ld hl, #Key_Esc
        call cpct_isKeyPressed_asm
        jr nz, _pause_3

    ld    l, #3
    ld    h, #3
    call cpct_setDrawCharM0_asm
    ld de, #0xC000
    ld c, #28
    ld b, #192
    call cpct_getScreenPtr_asm
    ld   iy, #string 
    call cpct_drawStringM0_asm
    
    ret